#ifndef __ASN1_H__
#define __ASN1_H__


#include <stdio.h>
#ifdef WIN32
#include <xom.h>
#include <xmp_cmis.h>
#include <usr_caBuff.h>
#include <usr_caBer.h>
#else /* WIN32 */
#include <cmip/xom.h>
#include <cmip/xmp_cmis.h>
#include <tmn_agent/usr_caBuff.h>
#include <tmn_agent/usr_caBer.h>
#endif /* WIN32 */





/* =============== Type PrintableString =============== */

typedef OctetString                   PrintableString;




/* =============== Type CFSObject_ASN1module_CfsId =============== */

typedef PrintableString               CFSObject_ASN1module_CfsId;




/* =============== Type CFSObject_ASN1module_CfsDirectory =============== */

typedef PrintableString               CFSObject_ASN1module_CfsDirectory;




/* =============== Type CFSObject_ASN1module_AutoUpdate =============== */

typedef OM_boolean                    CFSObject_ASN1module_AutoUpdate;




/* =============== Type CMIP_1_ObjectClass =============== */

typedef struct CMIP_1_ObjectClass {		/*  CMIP_1_ObjectClass ::= CHOICE { */
	enum {
		CMIP_1_ObjectClass_globalForm,
		CMIP_1_ObjectClass_localForm
	} choice;

	union CMIP_1_ObjectClassUnion {
		OM_object_identifier         globalForm;
		OM_integer                   localForm;
	} value;
} CMIP_1_ObjectClass;



/* =============== Type Attribute_ASN1Module_NameBinding =============== */

typedef OM_object_identifier          Attribute_ASN1Module_NameBinding;




/* =============== Type Attribute_ASN1Module_Packages =============== */

typedef struct Attribute_ASN1Module_PackagesNode {
	OM_object_identifier elt;
	struct Attribute_ASN1Module_PackagesNode *next;
	struct Attribute_ASN1Module_PackagesNode *prev;
} Attribute_ASN1Module_PackagesNode;

typedef struct Attribute_ASN1Module_Packages {	/* Attribute_ASN1Module_Packages ::= SET OF OM_object_identifier */
	Attribute_ASN1Module_PackagesNode *head;
	Attribute_ASN1Module_PackagesNode *tail;
} Attribute_ASN1Module_Packages;



/* =============== Type Attribute_ASN1Module_ObjectClass =============== */

typedef CMIP_1_ObjectClass            Attribute_ASN1Module_ObjectClass;




/* =============== Type Attribute_ASN1Module_Allomorphs =============== */

typedef struct Attribute_ASN1Module_AllomorphsNode {
	Attribute_ASN1Module_ObjectClass elt;
	struct Attribute_ASN1Module_AllomorphsNode *next;
	struct Attribute_ASN1Module_AllomorphsNode *prev;
} Attribute_ASN1Module_AllomorphsNode;

typedef struct Attribute_ASN1Module_Allomorphs {	/* Attribute_ASN1Module_Allomorphs ::= SET OF Attribute_ASN1Module_ObjectClass */
	Attribute_ASN1Module_AllomorphsNode *head;
	Attribute_ASN1Module_AllomorphsNode *tail;
} Attribute_ASN1Module_Allomorphs;



/* =============== Type CFSObject_ASN1module_PermissionBits =============== */

typedef struct CFSObject_ASN1module_PermissionBits {		/*  CFSObject_ASN1module_PermissionBits ::= SEQUENCE { */
	OM_boolean                   read;
	OM_boolean                   write;
	OM_boolean                   execute;
} CFSObject_ASN1module_PermissionBits;



/* =============== Type CFSObject_ASN1module_FilePermissions =============== */

typedef struct CFSObject_ASN1module_FilePermissions {		/*  CFSObject_ASN1module_FilePermissions ::= SEQUENCE { */
	CFSObject_ASN1module_PermissionBits user;
	CFSObject_ASN1module_PermissionBits group;
	CFSObject_ASN1module_PermissionBits other;
} CFSObject_ASN1module_FilePermissions;



/* =============== Type GraphicString =============== */

typedef OctetString                   GraphicString;




/* =============== Type Attribute_ASN1Module_SystemId =============== */

typedef struct Attribute_ASN1Module_SystemId {		/*  Attribute_ASN1Module_SystemId ::= CHOICE { */
	enum {
		Attribute_ASN1Module_SystemId_name,
		Attribute_ASN1Module_SystemId_number,
		Attribute_ASN1Module_SystemId_nothing
	} choice;

	union Attribute_ASN1Module_SystemIdUnion {
		GraphicString                name;
		OM_integer                   number;
	} value;
} Attribute_ASN1Module_SystemId;



/* =============== Type InformationFramework_AttributeType =============== */

typedef OM_object_identifier          InformationFramework_AttributeType;




/* =============== Type InformationFramework_AttributeValue =============== */

typedef OM_descriptor                 InformationFramework_AttributeValue;




/* =============== Type InformationFramework_AttributeValueAssertion =============== */

typedef struct InformationFramework_AttributeValueAssertion {		/*  InformationFramework_AttributeValueAssertion ::= SEQUENCE { */
	InformationFramework_AttributeType unnamedfield1;
	InformationFramework_AttributeValue unnamedfield2;
} InformationFramework_AttributeValueAssertion;



/* =============== Type InformationFramework_RelativeDistinguishedName =============== */

typedef struct InformationFramework_RelativeDistinguishedNameNode {
	InformationFramework_AttributeValueAssertion elt;
	struct InformationFramework_RelativeDistinguishedNameNode *next;
	struct InformationFramework_RelativeDistinguishedNameNode *prev;
} InformationFramework_RelativeDistinguishedNameNode;

typedef struct InformationFramework_RelativeDistinguishedName {	/* InformationFramework_RelativeDistinguishedName ::= SET OF InformationFramework_AttributeValueAssertion */
	InformationFramework_RelativeDistinguishedNameNode *head;
	InformationFramework_RelativeDistinguishedNameNode *tail;
} InformationFramework_RelativeDistinguishedName;



/* =============== Type InformationFramework_RDNSequence =============== */

typedef struct InformationFramework_RDNSequenceNode {
	InformationFramework_RelativeDistinguishedName elt;
	struct InformationFramework_RDNSequenceNode *next;
	struct InformationFramework_RDNSequenceNode *prev;
} InformationFramework_RDNSequenceNode;

typedef struct InformationFramework_RDNSequence {	/* InformationFramework_RDNSequence ::= SEQUENCE OF InformationFramework_RelativeDistinguishedName */
	InformationFramework_RDNSequenceNode *head;
	InformationFramework_RDNSequenceNode *tail;
} InformationFramework_RDNSequence;



/* =============== Type InformationFramework_DistinguishedName =============== */

typedef InformationFramework_RDNSequence  InformationFramework_DistinguishedName;




/* =============== Type Attribute_ASN1Module_DistinguishedName =============== */

typedef InformationFramework_DistinguishedName  Attribute_ASN1Module_DistinguishedName;




/* =============== Type Attribute_ASN1Module_SystemTitle =============== */

typedef struct Attribute_ASN1Module_SystemTitle {		/*  Attribute_ASN1Module_SystemTitle ::= CHOICE { */
	enum {
		Attribute_ASN1Module_SystemTitle_distinguishedName,
		Attribute_ASN1Module_SystemTitle_oid,
		Attribute_ASN1Module_SystemTitle_nothing
	} choice;

	union Attribute_ASN1Module_SystemTitleUnion {
		Attribute_ASN1Module_DistinguishedName distinguishedName;
		OM_object_identifier         oid;
	} value;
} Attribute_ASN1Module_SystemTitle;



/* =============== Type Attribute_ASN1Module_OperationalState =============== */

typedef enum Attribute_ASN1Module_OperationalState {		/*  Attribute_ASN1Module_OperationalState ::= ENUMERATED { */
	Attribute_ASN1Module_OperationalState_disabled=0,
	Attribute_ASN1Module_OperationalState_enabled=1
} Attribute_ASN1Module_OperationalState;




/* =============== Type Attribute_ASN1Module_UsageState =============== */

typedef enum Attribute_ASN1Module_UsageState {		/*  Attribute_ASN1Module_UsageState ::= ENUMERATED { */
	Attribute_ASN1Module_UsageState_idle=0,
	Attribute_ASN1Module_UsageState_active=1,
	Attribute_ASN1Module_UsageState_busy=2
} Attribute_ASN1Module_UsageState;




/* =============== Type Attribute_ASN1Module_AdministrativeState =============== */

typedef enum Attribute_ASN1Module_AdministrativeState {		/*  Attribute_ASN1Module_AdministrativeState ::= ENUMERATED { */
	Attribute_ASN1Module_AdministrativeState_locked=0,
	Attribute_ASN1Module_AdministrativeState_unlocked=1,
	Attribute_ASN1Module_AdministrativeState_shuttingDown=2
} Attribute_ASN1Module_AdministrativeState;




/* =============== Type Attribute_ASN1Module_SupportedFeatures_SeqT =============== */

typedef struct Attribute_ASN1Module_SupportedFeatures_SeqT {		/*  Attribute_ASN1Module_SupportedFeatures_SeqT ::= SEQUENCE { */
	OM_object_identifier         featureIdentifier;
	OM_descriptor                featureInfo;
} Attribute_ASN1Module_SupportedFeatures_SeqT;



/* =============== Type Attribute_ASN1Module_SupportedFeatures =============== */

typedef struct Attribute_ASN1Module_SupportedFeaturesNode {
	Attribute_ASN1Module_SupportedFeatures_SeqT elt;
	struct Attribute_ASN1Module_SupportedFeaturesNode *next;
	struct Attribute_ASN1Module_SupportedFeaturesNode *prev;
} Attribute_ASN1Module_SupportedFeaturesNode;

typedef struct Attribute_ASN1Module_SupportedFeatures {	/* Attribute_ASN1Module_SupportedFeatures ::= SET OF Attribute_ASN1Module_SupportedFeatures_SeqT */
	Attribute_ASN1Module_SupportedFeaturesNode *head;
	Attribute_ASN1Module_SupportedFeaturesNode *tail;
} Attribute_ASN1Module_SupportedFeatures;



/* =============== Type Attribute_ASN1Module_SourceIndicator =============== */

typedef enum Attribute_ASN1Module_SourceIndicator {		/*  Attribute_ASN1Module_SourceIndicator ::= ENUMERATED { */
	Attribute_ASN1Module_SourceIndicator_resourceOperation=0,
	Attribute_ASN1Module_SourceIndicator_managementOperation=1,
	Attribute_ASN1Module_SourceIndicator_unknown=2
} Attribute_ASN1Module_SourceIndicator;




/* =============== Type Notification_ASN1Module_SourceIndicator =============== */

typedef Attribute_ASN1Module_SourceIndicator  Notification_ASN1Module_SourceIndicator;




/* =============== Type CMIP_1_AttributeId =============== */

typedef struct CMIP_1_AttributeId {		/*  CMIP_1_AttributeId ::= CHOICE { */
	enum {
		CMIP_1_AttributeId_globalForm,
		CMIP_1_AttributeId_localForm
	} choice;

	union CMIP_1_AttributeIdUnion {
		OM_object_identifier         globalForm;
		OM_integer                   localForm;
	} value;
} CMIP_1_AttributeId;



/* =============== Type Attribute_ASN1Module_AttributeId =============== */

typedef CMIP_1_AttributeId            Attribute_ASN1Module_AttributeId;




/* =============== Type Attribute_ASN1Module_AttributeIdentifierList =============== */

typedef struct Attribute_ASN1Module_AttributeIdentifierListNode {
	Attribute_ASN1Module_AttributeId elt;
	struct Attribute_ASN1Module_AttributeIdentifierListNode *next;
	struct Attribute_ASN1Module_AttributeIdentifierListNode *prev;
} Attribute_ASN1Module_AttributeIdentifierListNode;

typedef struct Attribute_ASN1Module_AttributeIdentifierList {	/* Attribute_ASN1Module_AttributeIdentifierList ::= SET OF Attribute_ASN1Module_AttributeId */
	Attribute_ASN1Module_AttributeIdentifierListNode *head;
	Attribute_ASN1Module_AttributeIdentifierListNode *tail;
} Attribute_ASN1Module_AttributeIdentifierList;



/* =============== Type Notification_ASN1Module_AttributeIdentifierList =============== */

typedef Attribute_ASN1Module_AttributeIdentifierList  Notification_ASN1Module_AttributeIdentifierList;




/* =============== Type Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT =============== */

typedef struct Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT {		/*  Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT ::= SEQUENCE { */
	Attribute_ASN1Module_AttributeId attributeID;
	OM_descriptor                oldAttributeValue;
	OM_boolean                   oldAttributeValueIsPresent;
	OM_descriptor                newAttributeValue;
} Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT;



/* =============== Type Attribute_ASN1Module_AttributeValueChangeDefinition =============== */

typedef struct Attribute_ASN1Module_AttributeValueChangeDefinitionNode {
	Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT elt;
	struct Attribute_ASN1Module_AttributeValueChangeDefinitionNode *next;
	struct Attribute_ASN1Module_AttributeValueChangeDefinitionNode *prev;
} Attribute_ASN1Module_AttributeValueChangeDefinitionNode;

typedef struct Attribute_ASN1Module_AttributeValueChangeDefinition {	/* Attribute_ASN1Module_AttributeValueChangeDefinition ::= SET OF Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT */
	Attribute_ASN1Module_AttributeValueChangeDefinitionNode *head;
	Attribute_ASN1Module_AttributeValueChangeDefinitionNode *tail;
} Attribute_ASN1Module_AttributeValueChangeDefinition;



/* =============== Type Notification_ASN1Module_AttributeValueChangeDefinition =============== */

typedef Attribute_ASN1Module_AttributeValueChangeDefinition  Notification_ASN1Module_AttributeValueChangeDefinition;




/* =============== Type Attribute_ASN1Module_NotificationIdentifier =============== */

typedef OM_integer                    Attribute_ASN1Module_NotificationIdentifier;




/* =============== Type Notification_ASN1Module_NotificationIdentifier =============== */

typedef Attribute_ASN1Module_NotificationIdentifier  Notification_ASN1Module_NotificationIdentifier;




/* =============== Type Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT =============== */

typedef struct Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfTNode {
	Attribute_ASN1Module_NotificationIdentifier elt;
	struct Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfTNode *next;
	struct Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfTNode *prev;
} Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfTNode;

typedef struct Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT {	/* Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT ::= SET OF Attribute_ASN1Module_NotificationIdentifier */
	Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfTNode *head;
	Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfTNode *tail;
} Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT;



/* =============== Type CMIP_1_DistinguishedName =============== */

typedef InformationFramework_DistinguishedName  CMIP_1_DistinguishedName;




/* =============== Type CMIP_1_RDNSequence =============== */

typedef InformationFramework_RDNSequence  CMIP_1_RDNSequence;




/* =============== Type CMIP_1_ObjectInstance =============== */

typedef struct CMIP_1_ObjectInstance {		/*  CMIP_1_ObjectInstance ::= CHOICE { */
	enum {
		CMIP_1_ObjectInstance_distinguishedName,
		CMIP_1_ObjectInstance_nonSpecificForm,
		CMIP_1_ObjectInstance_localDistinguishedName
	} choice;

	union CMIP_1_ObjectInstanceUnion {
		CMIP_1_DistinguishedName     distinguishedName;
		OctetString                  nonSpecificForm;
		CMIP_1_RDNSequence           localDistinguishedName;
	} value;
} CMIP_1_ObjectInstance;



/* =============== Type Attribute_ASN1Module_ObjectInstance =============== */

typedef CMIP_1_ObjectInstance         Attribute_ASN1Module_ObjectInstance;




/* =============== Type Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT =============== */

typedef struct Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT {		/*  Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT ::= SEQUENCE { */
	Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT correlatedNotifications;
	Attribute_ASN1Module_ObjectInstance sourceObjectInst;
	OM_boolean                   sourceObjectInstIsPresent;
} Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT;



/* =============== Type Attribute_ASN1Module_CorrelatedNotifications =============== */

typedef struct Attribute_ASN1Module_CorrelatedNotificationsNode {
	Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT elt;
	struct Attribute_ASN1Module_CorrelatedNotificationsNode *next;
	struct Attribute_ASN1Module_CorrelatedNotificationsNode *prev;
} Attribute_ASN1Module_CorrelatedNotificationsNode;

typedef struct Attribute_ASN1Module_CorrelatedNotifications {	/* Attribute_ASN1Module_CorrelatedNotifications ::= SET OF Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT */
	Attribute_ASN1Module_CorrelatedNotificationsNode *head;
	Attribute_ASN1Module_CorrelatedNotificationsNode *tail;
} Attribute_ASN1Module_CorrelatedNotifications;



/* =============== Type Notification_ASN1Module_CorrelatedNotifications =============== */

typedef Attribute_ASN1Module_CorrelatedNotifications  Notification_ASN1Module_CorrelatedNotifications;




/* =============== Type Attribute_ASN1Module_AdditionalText =============== */

typedef GraphicString                 Attribute_ASN1Module_AdditionalText;




/* =============== Type Notification_ASN1Module_AdditionalText =============== */

typedef Attribute_ASN1Module_AdditionalText  Notification_ASN1Module_AdditionalText;




/* =============== Type Attribute_ASN1Module_ManagementExtension =============== */

typedef struct Attribute_ASN1Module_ManagementExtension {		/*  Attribute_ASN1Module_ManagementExtension ::= SEQUENCE { */
	OM_object_identifier         identifier;
	OM_boolean                   significance;
	OM_descriptor                information;
} Attribute_ASN1Module_ManagementExtension;



/* =============== Type Attribute_ASN1Module_AdditionalInformation =============== */

typedef struct Attribute_ASN1Module_AdditionalInformationNode {
	Attribute_ASN1Module_ManagementExtension elt;
	struct Attribute_ASN1Module_AdditionalInformationNode *next;
	struct Attribute_ASN1Module_AdditionalInformationNode *prev;
} Attribute_ASN1Module_AdditionalInformationNode;

typedef struct Attribute_ASN1Module_AdditionalInformation {	/* Attribute_ASN1Module_AdditionalInformation ::= SET OF Attribute_ASN1Module_ManagementExtension */
	Attribute_ASN1Module_AdditionalInformationNode *head;
	Attribute_ASN1Module_AdditionalInformationNode *tail;
} Attribute_ASN1Module_AdditionalInformation;



/* =============== Type Notification_ASN1Module_AdditionalInformation =============== */

typedef Attribute_ASN1Module_AdditionalInformation  Notification_ASN1Module_AdditionalInformation;




/* =============== Type Notification_ASN1Module_AttributeValueChangeInfo =============== */

typedef struct Notification_ASN1Module_AttributeValueChangeInfo {		/*  Notification_ASN1Module_AttributeValueChangeInfo ::= SEQUENCE { */
	Notification_ASN1Module_SourceIndicator sourceIndicator;
	OM_boolean                   sourceIndicatorIsPresent;
	Notification_ASN1Module_AttributeIdentifierList attributeIdentifierList;
	OM_boolean                   attributeIdentifierListIsPresent;
	Notification_ASN1Module_AttributeValueChangeDefinition attributeValueChangeDefinition;
	Notification_ASN1Module_NotificationIdentifier notificationIdentifier;
	OM_boolean                   notificationIdentifierIsPresent;
	Notification_ASN1Module_CorrelatedNotifications correlatedNotifications;
	OM_boolean                   correlatedNotificationsIsPresent;
	Notification_ASN1Module_AdditionalText additionalText;
	OM_boolean                   additionalTextIsPresent;
	Notification_ASN1Module_AdditionalInformation additionalInformation;
	OM_boolean                   additionalInformationIsPresent;
} Notification_ASN1Module_AttributeValueChangeInfo;



/* =============== Type CMIP_1_Attribute =============== */

typedef struct CMIP_1_Attribute {		/*  CMIP_1_Attribute ::= SEQUENCE { */
	CMIP_1_AttributeId           attributeId;
	OM_descriptor                attributeValue;
} CMIP_1_Attribute;



/* =============== Type Attribute_ASN1Module_Attribute =============== */

typedef CMIP_1_Attribute              Attribute_ASN1Module_Attribute;




/* =============== Type Attribute_ASN1Module_AttributeList =============== */

typedef struct Attribute_ASN1Module_AttributeListNode {
	Attribute_ASN1Module_Attribute elt;
	struct Attribute_ASN1Module_AttributeListNode *next;
	struct Attribute_ASN1Module_AttributeListNode *prev;
} Attribute_ASN1Module_AttributeListNode;

typedef struct Attribute_ASN1Module_AttributeList {	/* Attribute_ASN1Module_AttributeList ::= SET OF Attribute_ASN1Module_Attribute */
	Attribute_ASN1Module_AttributeListNode *head;
	Attribute_ASN1Module_AttributeListNode *tail;
} Attribute_ASN1Module_AttributeList;



/* =============== Type Notification_ASN1Module_AttributeList =============== */

typedef Attribute_ASN1Module_AttributeList  Notification_ASN1Module_AttributeList;




/* =============== Type Notification_ASN1Module_ObjectInfo =============== */

typedef struct Notification_ASN1Module_ObjectInfo {		/*  Notification_ASN1Module_ObjectInfo ::= SEQUENCE { */
	Notification_ASN1Module_SourceIndicator sourceIndicator;
	OM_boolean                   sourceIndicatorIsPresent;
	Notification_ASN1Module_AttributeList attributeList;
	OM_boolean                   attributeListIsPresent;
	Notification_ASN1Module_NotificationIdentifier notificationIdentifier;
	OM_boolean                   notificationIdentifierIsPresent;
	Notification_ASN1Module_CorrelatedNotifications correlatedNotifications;
	OM_boolean                   correlatedNotificationsIsPresent;
	Notification_ASN1Module_AdditionalText additionalText;
	OM_boolean                   additionalTextIsPresent;
	Notification_ASN1Module_AdditionalInformation additionalInformation;
	OM_boolean                   additionalInformationIsPresent;
} Notification_ASN1Module_ObjectInfo;



extern OM_return_code enc_PrintableString_content(PrintableString *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

#define enc_CFSObject_ASN1module_CfsId_content enc_PrintableString_content
#define enc_CFSObject_ASN1module_CfsDirectory_content enc_PrintableString_content
#define enc_CFSObject_ASN1module_AutoUpdate_content ca_ber_enc_Boolean_content
extern OM_return_code enc_CMIP_1_ObjectClass_content(CMIP_1_ObjectClass *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

#define enc_Attribute_ASN1Module_NameBinding_content ca_ber_enc_ObjectId_content
extern OM_return_code enc_Attribute_ASN1Module_Packages_content(Attribute_ASN1Module_Packages *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

#define enc_Attribute_ASN1Module_ObjectClass_content enc_CMIP_1_ObjectClass_content
extern OM_return_code enc_Attribute_ASN1Module_Allomorphs_content(Attribute_ASN1Module_Allomorphs *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

extern OM_return_code enc_CFSObject_ASN1module_PermissionBits_content(CFSObject_ASN1module_PermissionBits *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

extern OM_return_code enc_CFSObject_ASN1module_FilePermissions_content(CFSObject_ASN1module_FilePermissions *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

extern OM_return_code enc_GraphicString_content(GraphicString *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

extern OM_return_code enc_Attribute_ASN1Module_SystemId_content(Attribute_ASN1Module_SystemId *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

#define enc_InformationFramework_AttributeType_content ca_ber_enc_ObjectId_content
#define enc_InformationFramework_AttributeValue_content ca_ber_enc_Any_content
extern OM_return_code enc_InformationFramework_AttributeValueAssertion_content(InformationFramework_AttributeValueAssertion *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

extern OM_return_code enc_InformationFramework_RelativeDistinguishedName_content(InformationFramework_RelativeDistinguishedName *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

extern OM_return_code enc_InformationFramework_RDNSequence_content(InformationFramework_RDNSequence *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

#define enc_InformationFramework_DistinguishedName_content enc_InformationFramework_RDNSequence_content
#define enc_Attribute_ASN1Module_DistinguishedName_content enc_InformationFramework_DistinguishedName_content
extern OM_return_code enc_Attribute_ASN1Module_SystemTitle_content(Attribute_ASN1Module_SystemTitle *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

#define enc_Attribute_ASN1Module_OperationalState_content ca_ber_enc_Enum_content
#define enc_Attribute_ASN1Module_UsageState_content ca_ber_enc_Enum_content
#define enc_Attribute_ASN1Module_AdministrativeState_content ca_ber_enc_Enum_content
extern OM_return_code enc_Attribute_ASN1Module_SupportedFeatures_SeqT_content(Attribute_ASN1Module_SupportedFeatures_SeqT *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

extern OM_return_code enc_Attribute_ASN1Module_SupportedFeatures_content(Attribute_ASN1Module_SupportedFeatures *value,
			ca_buff_t * contBuffer, int * contLen,
			ca_buff_t * tagBuffer, int * tagLen, int *tagForm);

extern OM_return_code enc_CFSObject_ASN1module_CfsId(CFSObject_ASN1module_CfsId *value,
			OM_descriptor * encoding);

extern OM_return_code enc_CFSObject_ASN1module_CfsDirectory(CFSObject_ASN1module_CfsDirectory *value,
			OM_descriptor * encoding);

extern OM_return_code enc_CFSObject_ASN1module_AutoUpdate(CFSObject_ASN1module_AutoUpdate *value,
			OM_descriptor * encoding);

extern OM_return_code enc_CMIP_1_ObjectClass(CMIP_1_ObjectClass *value,
			OM_descriptor * encoding);

extern OM_return_code enc_Attribute_ASN1Module_NameBinding(Attribute_ASN1Module_NameBinding *value,
			OM_descriptor * encoding);

extern OM_return_code enc_Attribute_ASN1Module_Packages(Attribute_ASN1Module_Packages *value,
			OM_descriptor * encoding);

extern OM_return_code enc_Attribute_ASN1Module_Allomorphs(Attribute_ASN1Module_Allomorphs *value,
			OM_descriptor * encoding);

extern OM_return_code enc_CFSObject_ASN1module_FilePermissions(CFSObject_ASN1module_FilePermissions *value,
			OM_descriptor * encoding);

extern OM_return_code enc_Attribute_ASN1Module_SystemId(Attribute_ASN1Module_SystemId *value,
			OM_descriptor * encoding);

extern OM_return_code enc_Attribute_ASN1Module_SystemTitle(Attribute_ASN1Module_SystemTitle *value,
			OM_descriptor * encoding);

extern OM_return_code enc_Attribute_ASN1Module_OperationalState(Attribute_ASN1Module_OperationalState *value,
			OM_descriptor * encoding);

extern OM_return_code enc_Attribute_ASN1Module_UsageState(Attribute_ASN1Module_UsageState *value,
			OM_descriptor * encoding);

extern OM_return_code enc_Attribute_ASN1Module_AdministrativeState(Attribute_ASN1Module_AdministrativeState *value,
			OM_descriptor * encoding);

extern OM_return_code enc_Attribute_ASN1Module_SupportedFeatures(Attribute_ASN1Module_SupportedFeatures *value,
			OM_descriptor * encoding);


extern OM_return_code dec_PrintableString_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			PrintableString *value, int *decLen);
#define dec_CFSObject_ASN1module_CfsId_content dec_PrintableString_content
#define dec_CFSObject_ASN1module_CfsDirectory_content dec_PrintableString_content
#define dec_CFSObject_ASN1module_AutoUpdate_content ca_ber_dec_Boolean_content

extern OM_return_code dec_CMIP_1_ObjectClass_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			CMIP_1_ObjectClass *value, int *decLen);
#define dec_Attribute_ASN1Module_NameBinding_content ca_ber_dec_ObjectId_content

extern OM_return_code dec_Attribute_ASN1Module_Packages_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_Packages *value, int *decLen);
#define dec_Attribute_ASN1Module_ObjectClass_content dec_CMIP_1_ObjectClass_content

extern OM_return_code dec_Attribute_ASN1Module_Allomorphs_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_Allomorphs *value, int *decLen);
#define dec_Attribute_ASN1Module_SourceIndicator_content ca_ber_dec_Enum_content
#define dec_Notification_ASN1Module_SourceIndicator_content dec_Attribute_ASN1Module_SourceIndicator_content

extern OM_return_code dec_CMIP_1_AttributeId_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			CMIP_1_AttributeId *value, int *decLen);
#define dec_Attribute_ASN1Module_AttributeId_content dec_CMIP_1_AttributeId_content

extern OM_return_code dec_Attribute_ASN1Module_AttributeIdentifierList_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_AttributeIdentifierList *value, int *decLen);
#define dec_Notification_ASN1Module_AttributeIdentifierList_content dec_Attribute_ASN1Module_AttributeIdentifierList_content

extern OM_return_code dec_Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT *value, int *decLen);

extern OM_return_code dec_Attribute_ASN1Module_AttributeValueChangeDefinition_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_AttributeValueChangeDefinition *value, int *decLen);
#define dec_Notification_ASN1Module_AttributeValueChangeDefinition_content dec_Attribute_ASN1Module_AttributeValueChangeDefinition_content
#define dec_Attribute_ASN1Module_NotificationIdentifier_content ca_ber_dec_Integer_content
#define dec_Notification_ASN1Module_NotificationIdentifier_content dec_Attribute_ASN1Module_NotificationIdentifier_content

extern OM_return_code dec_Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT *value, int *decLen);
#define dec_InformationFramework_AttributeType_content ca_ber_dec_ObjectId_content
#define dec_InformationFramework_AttributeValue_content ca_ber_dec_Any_content

extern OM_return_code dec_InformationFramework_AttributeValueAssertion_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			InformationFramework_AttributeValueAssertion *value, int *decLen);

extern OM_return_code dec_InformationFramework_RelativeDistinguishedName_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			InformationFramework_RelativeDistinguishedName *value, int *decLen);

extern OM_return_code dec_InformationFramework_RDNSequence_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			InformationFramework_RDNSequence *value, int *decLen);
#define dec_InformationFramework_DistinguishedName_content dec_InformationFramework_RDNSequence_content
#define dec_CMIP_1_DistinguishedName_content dec_InformationFramework_DistinguishedName_content
#define dec_CMIP_1_RDNSequence_content dec_InformationFramework_RDNSequence_content

extern OM_return_code dec_CMIP_1_ObjectInstance_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			CMIP_1_ObjectInstance *value, int *decLen);
#define dec_Attribute_ASN1Module_ObjectInstance_content dec_CMIP_1_ObjectInstance_content

extern OM_return_code dec_Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT *value, int *decLen);

extern OM_return_code dec_Attribute_ASN1Module_CorrelatedNotifications_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_CorrelatedNotifications *value, int *decLen);
#define dec_Notification_ASN1Module_CorrelatedNotifications_content dec_Attribute_ASN1Module_CorrelatedNotifications_content

extern OM_return_code dec_GraphicString_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			GraphicString *value, int *decLen);
#define dec_Attribute_ASN1Module_AdditionalText_content dec_GraphicString_content
#define dec_Notification_ASN1Module_AdditionalText_content dec_Attribute_ASN1Module_AdditionalText_content

extern OM_return_code dec_Attribute_ASN1Module_ManagementExtension_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_ManagementExtension *value, int *decLen);

extern OM_return_code dec_Attribute_ASN1Module_AdditionalInformation_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_AdditionalInformation *value, int *decLen);
#define dec_Notification_ASN1Module_AdditionalInformation_content dec_Attribute_ASN1Module_AdditionalInformation_content

extern OM_return_code dec_Notification_ASN1Module_AttributeValueChangeInfo_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Notification_ASN1Module_AttributeValueChangeInfo *value, int *decLen);

extern OM_return_code dec_CFSObject_ASN1module_PermissionBits_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			CFSObject_ASN1module_PermissionBits *value, int *decLen);

extern OM_return_code dec_CFSObject_ASN1module_FilePermissions_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			CFSObject_ASN1module_FilePermissions *value, int *decLen);

extern OM_return_code dec_CMIP_1_Attribute_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			CMIP_1_Attribute *value, int *decLen);
#define dec_Attribute_ASN1Module_Attribute_content dec_CMIP_1_Attribute_content

extern OM_return_code dec_Attribute_ASN1Module_AttributeList_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_AttributeList *value, int *decLen);
#define dec_Notification_ASN1Module_AttributeList_content dec_Attribute_ASN1Module_AttributeList_content

extern OM_return_code dec_Notification_ASN1Module_ObjectInfo_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Notification_ASN1Module_ObjectInfo *value, int *decLen);

extern OM_return_code dec_Attribute_ASN1Module_SystemId_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_SystemId *value, int *decLen);
#define dec_Attribute_ASN1Module_DistinguishedName_content dec_InformationFramework_DistinguishedName_content

extern OM_return_code dec_Attribute_ASN1Module_SystemTitle_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_SystemTitle *value, int *decLen);
#define dec_Attribute_ASN1Module_OperationalState_content ca_ber_dec_Enum_content
#define dec_Attribute_ASN1Module_UsageState_content ca_ber_dec_Enum_content
#define dec_Attribute_ASN1Module_AdministrativeState_content ca_ber_dec_Enum_content

extern OM_return_code dec_Attribute_ASN1Module_SupportedFeatures_SeqT_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_SupportedFeatures_SeqT *value, int *decLen);

extern OM_return_code dec_Attribute_ASN1Module_SupportedFeatures_content(ca_buff_t * contBuffer, int contLen,
			unsigned char tagIsExplicit,
			int tagValue, int tagClass, int tagForm,
			Attribute_ASN1Module_SupportedFeatures *value, int *decLen);
/* Decoding functions for type CFSObject_ASN1module_CfsId */

extern OM_return_code dec_CFSObject_ASN1module_CfsId(OM_descriptor *encoding,
			CFSObject_ASN1module_CfsId *value);

/* Decoding functions for type CFSObject_ASN1module_CfsDirectory */

extern OM_return_code dec_CFSObject_ASN1module_CfsDirectory(OM_descriptor *encoding,
			CFSObject_ASN1module_CfsDirectory *value);

/* Decoding functions for type CFSObject_ASN1module_AutoUpdate */

extern OM_return_code dec_CFSObject_ASN1module_AutoUpdate(OM_descriptor *encoding,
			CFSObject_ASN1module_AutoUpdate *value);

/* Decoding functions for type CMIP_1_ObjectClass */

extern OM_return_code dec_CMIP_1_ObjectClass(OM_descriptor *encoding,
			CMIP_1_ObjectClass *value);

/* Decoding functions for type Attribute_ASN1Module_NameBinding */

extern OM_return_code dec_Attribute_ASN1Module_NameBinding(OM_descriptor *encoding,
			Attribute_ASN1Module_NameBinding *value);

/* Decoding functions for type Attribute_ASN1Module_Packages */

extern OM_return_code dec_Attribute_ASN1Module_Packages(OM_descriptor *encoding,
			Attribute_ASN1Module_Packages *value);

/* Decoding functions for type Attribute_ASN1Module_Allomorphs */

extern OM_return_code dec_Attribute_ASN1Module_Allomorphs(OM_descriptor *encoding,
			Attribute_ASN1Module_Allomorphs *value);

/* Decoding functions for type Notification_ASN1Module_AttributeValueChangeInfo */

extern OM_return_code dec_Notification_ASN1Module_AttributeValueChangeInfo(OM_descriptor *encoding,
			Notification_ASN1Module_AttributeValueChangeInfo *value);

/* Decoding functions for type CFSObject_ASN1module_FilePermissions */

extern OM_return_code dec_CFSObject_ASN1module_FilePermissions(OM_descriptor *encoding,
			CFSObject_ASN1module_FilePermissions *value);

/* Decoding functions for type Notification_ASN1Module_ObjectInfo */

extern OM_return_code dec_Notification_ASN1Module_ObjectInfo(OM_descriptor *encoding,
			Notification_ASN1Module_ObjectInfo *value);

/* Decoding functions for type Attribute_ASN1Module_SystemId */

extern OM_return_code dec_Attribute_ASN1Module_SystemId(OM_descriptor *encoding,
			Attribute_ASN1Module_SystemId *value);

/* Decoding functions for type Attribute_ASN1Module_SystemTitle */

extern OM_return_code dec_Attribute_ASN1Module_SystemTitle(OM_descriptor *encoding,
			Attribute_ASN1Module_SystemTitle *value);

/* Decoding functions for type Attribute_ASN1Module_OperationalState */

extern OM_return_code dec_Attribute_ASN1Module_OperationalState(OM_descriptor *encoding,
			Attribute_ASN1Module_OperationalState *value);

/* Decoding functions for type Attribute_ASN1Module_UsageState */

extern OM_return_code dec_Attribute_ASN1Module_UsageState(OM_descriptor *encoding,
			Attribute_ASN1Module_UsageState *value);

/* Decoding functions for type Attribute_ASN1Module_AdministrativeState */

extern OM_return_code dec_Attribute_ASN1Module_AdministrativeState(OM_descriptor *encoding,
			Attribute_ASN1Module_AdministrativeState *value);

/* Decoding functions for type Attribute_ASN1Module_SupportedFeatures */

extern OM_return_code dec_Attribute_ASN1Module_SupportedFeatures(OM_descriptor *encoding,
			Attribute_ASN1Module_SupportedFeatures *value);

#define print_PrintableString(f, v, i) ca_ber_print_OctetString(f, v)
#define print_CFSObject_ASN1module_CfsId print_PrintableString
#define print_CFSObject_ASN1module_CfsDirectory print_PrintableString
#define print_CFSObject_ASN1module_AutoUpdate(f, v, i) ca_ber_print_Boolean(f, v)
/* Printing function for type CMIP_1_ObjectClass */

extern void print_CMIP_1_ObjectClass(FILE *f, CMIP_1_ObjectClass *value, unsigned short indent);

#define print_Attribute_ASN1Module_NameBinding(f, v, i) ca_ber_print_ObjectId(f, v)
/* Printing function for type Attribute_ASN1Module_Packages */

extern void print_Attribute_ASN1Module_Packages(FILE *f, Attribute_ASN1Module_Packages *value, unsigned short indent);

#define print_Attribute_ASN1Module_ObjectClass print_CMIP_1_ObjectClass
/* Printing function for type Attribute_ASN1Module_Allomorphs */

extern void print_Attribute_ASN1Module_Allomorphs(FILE *f, Attribute_ASN1Module_Allomorphs *value, unsigned short indent);

/* Printing function for type CFSObject_ASN1module_PermissionBits */

extern void print_CFSObject_ASN1module_PermissionBits(FILE *f, CFSObject_ASN1module_PermissionBits *value, unsigned short indent);

/* Printing function for type CFSObject_ASN1module_FilePermissions */

extern void print_CFSObject_ASN1module_FilePermissions(FILE *f, CFSObject_ASN1module_FilePermissions *value, unsigned short indent);

#define print_GraphicString(f, v, i) ca_ber_print_OctetString(f, v)
/* Printing function for type Attribute_ASN1Module_SystemId */

extern void print_Attribute_ASN1Module_SystemId(FILE *f, Attribute_ASN1Module_SystemId *value, unsigned short indent);

#define print_InformationFramework_AttributeType(f, v, i) ca_ber_print_ObjectId(f, v)
#define print_InformationFramework_AttributeValue(f, v, i) ca_ber_print_Any(f, v)
/* Printing function for type InformationFramework_AttributeValueAssertion */

extern void print_InformationFramework_AttributeValueAssertion(FILE *f, InformationFramework_AttributeValueAssertion *value, unsigned short indent);

/* Printing function for type InformationFramework_RelativeDistinguishedName */

extern void print_InformationFramework_RelativeDistinguishedName(FILE *f, InformationFramework_RelativeDistinguishedName *value, unsigned short indent);

/* Printing function for type InformationFramework_RDNSequence */

extern void print_InformationFramework_RDNSequence(FILE *f, InformationFramework_RDNSequence *value, unsigned short indent);

#define print_InformationFramework_DistinguishedName print_InformationFramework_RDNSequence
#define print_Attribute_ASN1Module_DistinguishedName print_InformationFramework_DistinguishedName
/* Printing function for type Attribute_ASN1Module_SystemTitle */

extern void print_Attribute_ASN1Module_SystemTitle(FILE *f, Attribute_ASN1Module_SystemTitle *value, unsigned short indent);

#define print_Attribute_ASN1Module_OperationalState(f, v, i) ca_ber_print_Enum(f, v)
#define print_Attribute_ASN1Module_UsageState(f, v, i) ca_ber_print_Enum(f, v)
#define print_Attribute_ASN1Module_AdministrativeState(f, v, i) ca_ber_print_Enum(f, v)
/* Printing function for type Attribute_ASN1Module_SupportedFeatures_SeqT */

extern void print_Attribute_ASN1Module_SupportedFeatures_SeqT(FILE *f, Attribute_ASN1Module_SupportedFeatures_SeqT *value, unsigned short indent);

/* Printing function for type Attribute_ASN1Module_SupportedFeatures */

extern void print_Attribute_ASN1Module_SupportedFeatures(FILE *f, Attribute_ASN1Module_SupportedFeatures *value, unsigned short indent);

#define print_Attribute_ASN1Module_SourceIndicator(f, v, i) ca_ber_print_Enum(f, v)
#define print_Notification_ASN1Module_SourceIndicator print_Attribute_ASN1Module_SourceIndicator
/* Printing function for type CMIP_1_AttributeId */

extern void print_CMIP_1_AttributeId(FILE *f, CMIP_1_AttributeId *value, unsigned short indent);

#define print_Attribute_ASN1Module_AttributeId print_CMIP_1_AttributeId
/* Printing function for type Attribute_ASN1Module_AttributeIdentifierList */

extern void print_Attribute_ASN1Module_AttributeIdentifierList(FILE *f, Attribute_ASN1Module_AttributeIdentifierList *value, unsigned short indent);

#define print_Notification_ASN1Module_AttributeIdentifierList print_Attribute_ASN1Module_AttributeIdentifierList
/* Printing function for type Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT */

extern void print_Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT(FILE *f, Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT *value, unsigned short indent);

/* Printing function for type Attribute_ASN1Module_AttributeValueChangeDefinition */

extern void print_Attribute_ASN1Module_AttributeValueChangeDefinition(FILE *f, Attribute_ASN1Module_AttributeValueChangeDefinition *value, unsigned short indent);

#define print_Notification_ASN1Module_AttributeValueChangeDefinition print_Attribute_ASN1Module_AttributeValueChangeDefinition
#define print_Attribute_ASN1Module_NotificationIdentifier(f, v, i) ca_ber_print_Integer(f, v)
#define print_Notification_ASN1Module_NotificationIdentifier print_Attribute_ASN1Module_NotificationIdentifier
/* Printing function for type Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT */

extern void print_Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT(FILE *f, Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT *value, unsigned short indent);

#define print_CMIP_1_DistinguishedName print_InformationFramework_DistinguishedName
#define print_CMIP_1_RDNSequence print_InformationFramework_RDNSequence
/* Printing function for type CMIP_1_ObjectInstance */

extern void print_CMIP_1_ObjectInstance(FILE *f, CMIP_1_ObjectInstance *value, unsigned short indent);

#define print_Attribute_ASN1Module_ObjectInstance print_CMIP_1_ObjectInstance
/* Printing function for type Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT */

extern void print_Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT(FILE *f, Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT *value, unsigned short indent);

/* Printing function for type Attribute_ASN1Module_CorrelatedNotifications */

extern void print_Attribute_ASN1Module_CorrelatedNotifications(FILE *f, Attribute_ASN1Module_CorrelatedNotifications *value, unsigned short indent);

#define print_Notification_ASN1Module_CorrelatedNotifications print_Attribute_ASN1Module_CorrelatedNotifications
#define print_Attribute_ASN1Module_AdditionalText print_GraphicString
#define print_Notification_ASN1Module_AdditionalText print_Attribute_ASN1Module_AdditionalText
/* Printing function for type Attribute_ASN1Module_ManagementExtension */

extern void print_Attribute_ASN1Module_ManagementExtension(FILE *f, Attribute_ASN1Module_ManagementExtension *value, unsigned short indent);

/* Printing function for type Attribute_ASN1Module_AdditionalInformation */

extern void print_Attribute_ASN1Module_AdditionalInformation(FILE *f, Attribute_ASN1Module_AdditionalInformation *value, unsigned short indent);

#define print_Notification_ASN1Module_AdditionalInformation print_Attribute_ASN1Module_AdditionalInformation
/* Printing function for type Notification_ASN1Module_AttributeValueChangeInfo */

extern void print_Notification_ASN1Module_AttributeValueChangeInfo(FILE *f, Notification_ASN1Module_AttributeValueChangeInfo *value, unsigned short indent);

/* Printing function for type CMIP_1_Attribute */

extern void print_CMIP_1_Attribute(FILE *f, CMIP_1_Attribute *value, unsigned short indent);

#define print_Attribute_ASN1Module_Attribute print_CMIP_1_Attribute
/* Printing function for type Attribute_ASN1Module_AttributeList */

extern void print_Attribute_ASN1Module_AttributeList(FILE *f, Attribute_ASN1Module_AttributeList *value, unsigned short indent);

#define print_Notification_ASN1Module_AttributeList print_Attribute_ASN1Module_AttributeList
/* Printing function for type Notification_ASN1Module_ObjectInfo */

extern void print_Notification_ASN1Module_ObjectInfo(FILE *f, Notification_ASN1Module_ObjectInfo *value, unsigned short indent);

#define free_PrintableString ca_ber_free_OctetString
#define free_CFSObject_ASN1module_CfsId free_PrintableString
#define free_CFSObject_ASN1module_CfsDirectory free_PrintableString
#define free_CFSObject_ASN1module_AutoUpdate ca_ber_free_Boolean
extern void free_CMIP_1_ObjectClass(CMIP_1_ObjectClass *value);
extern void free_Attribute_ASN1Module_NameBinding(Attribute_ASN1Module_NameBinding *value);
extern void free_Attribute_ASN1Module_Packages(Attribute_ASN1Module_Packages *value);
#define free_Attribute_ASN1Module_ObjectClass free_CMIP_1_ObjectClass
extern void free_Attribute_ASN1Module_Allomorphs(Attribute_ASN1Module_Allomorphs *value);
extern void free_CFSObject_ASN1module_PermissionBits(CFSObject_ASN1module_PermissionBits *value);
extern void free_CFSObject_ASN1module_FilePermissions(CFSObject_ASN1module_FilePermissions *value);
#define free_GraphicString ca_ber_free_OctetString
extern void free_Attribute_ASN1Module_SystemId(Attribute_ASN1Module_SystemId *value);
extern void free_InformationFramework_AttributeType(InformationFramework_AttributeType *value);
#define free_InformationFramework_AttributeValue ca_ber_free_Any
extern void free_InformationFramework_AttributeValueAssertion(InformationFramework_AttributeValueAssertion *value);
extern void free_InformationFramework_RelativeDistinguishedName(InformationFramework_RelativeDistinguishedName *value);
extern void free_InformationFramework_RDNSequence(InformationFramework_RDNSequence *value);
#define free_InformationFramework_DistinguishedName free_InformationFramework_RDNSequence
#define free_Attribute_ASN1Module_DistinguishedName free_InformationFramework_DistinguishedName
extern void free_Attribute_ASN1Module_SystemTitle(Attribute_ASN1Module_SystemTitle *value);
extern void free_Attribute_ASN1Module_OperationalState(Attribute_ASN1Module_OperationalState *value);
extern void free_Attribute_ASN1Module_UsageState(Attribute_ASN1Module_UsageState *value);
extern void free_Attribute_ASN1Module_AdministrativeState(Attribute_ASN1Module_AdministrativeState *value);
extern void free_Attribute_ASN1Module_SupportedFeatures_SeqT(Attribute_ASN1Module_SupportedFeatures_SeqT *value);
extern void free_Attribute_ASN1Module_SupportedFeatures(Attribute_ASN1Module_SupportedFeatures *value);
extern void free_Attribute_ASN1Module_SourceIndicator(Attribute_ASN1Module_SourceIndicator *value);
#define free_Notification_ASN1Module_SourceIndicator free_Attribute_ASN1Module_SourceIndicator
extern void free_CMIP_1_AttributeId(CMIP_1_AttributeId *value);
#define free_Attribute_ASN1Module_AttributeId free_CMIP_1_AttributeId
extern void free_Attribute_ASN1Module_AttributeIdentifierList(Attribute_ASN1Module_AttributeIdentifierList *value);
#define free_Notification_ASN1Module_AttributeIdentifierList free_Attribute_ASN1Module_AttributeIdentifierList
extern void free_Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT(Attribute_ASN1Module_AttributeValueChangeDefinition_SetOf_SeqT *value);
extern void free_Attribute_ASN1Module_AttributeValueChangeDefinition(Attribute_ASN1Module_AttributeValueChangeDefinition *value);
#define free_Notification_ASN1Module_AttributeValueChangeDefinition free_Attribute_ASN1Module_AttributeValueChangeDefinition
#define free_Attribute_ASN1Module_NotificationIdentifier ca_ber_free_Integer
#define free_Notification_ASN1Module_NotificationIdentifier free_Attribute_ASN1Module_NotificationIdentifier
extern void free_Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT(Attribute_ASN1Module_CorrelatedNotifications_SetOf_Seq_correlatedNotifications_SetOfT *value);
#define free_CMIP_1_DistinguishedName free_InformationFramework_DistinguishedName
#define free_CMIP_1_RDNSequence free_InformationFramework_RDNSequence
extern void free_CMIP_1_ObjectInstance(CMIP_1_ObjectInstance *value);
#define free_Attribute_ASN1Module_ObjectInstance free_CMIP_1_ObjectInstance
extern void free_Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT(Attribute_ASN1Module_CorrelatedNotifications_SetOf_SeqT *value);
extern void free_Attribute_ASN1Module_CorrelatedNotifications(Attribute_ASN1Module_CorrelatedNotifications *value);
#define free_Notification_ASN1Module_CorrelatedNotifications free_Attribute_ASN1Module_CorrelatedNotifications
#define free_Attribute_ASN1Module_AdditionalText free_GraphicString
#define free_Notification_ASN1Module_AdditionalText free_Attribute_ASN1Module_AdditionalText
extern void free_Attribute_ASN1Module_ManagementExtension(Attribute_ASN1Module_ManagementExtension *value);
extern void free_Attribute_ASN1Module_AdditionalInformation(Attribute_ASN1Module_AdditionalInformation *value);
#define free_Notification_ASN1Module_AdditionalInformation free_Attribute_ASN1Module_AdditionalInformation
extern void free_Notification_ASN1Module_AttributeValueChangeInfo(Notification_ASN1Module_AttributeValueChangeInfo *value);
extern void free_CMIP_1_Attribute(CMIP_1_Attribute *value);
#define free_Attribute_ASN1Module_Attribute free_CMIP_1_Attribute
extern void free_Attribute_ASN1Module_AttributeList(Attribute_ASN1Module_AttributeList *value);
#define free_Notification_ASN1Module_AttributeList free_Attribute_ASN1Module_AttributeList
extern void free_Notification_ASN1Module_ObjectInfo(Notification_ASN1Module_ObjectInfo *value);
#define cmp_PrintableString ca_ber_cmp_OctetString
#define cmp_CFSObject_ASN1module_CfsId cmp_PrintableString
#define cmp_CFSObject_ASN1module_CfsDirectory cmp_PrintableString
#define cmp_CFSObject_ASN1module_AutoUpdate ca_ber_cmp_Boolean
/* Comparing function for type CMIP_1_ObjectClass */

extern OM_boolean cmp_CMIP_1_ObjectClass(CMIP_1_ObjectClass *value1, CMIP_1_ObjectClass *value2, unsigned int operator);

#define cmp_Attribute_ASN1Module_NameBinding ca_ber_cmp_ObjectId
/* Comparing function for type Attribute_ASN1Module_Packages */

extern OM_boolean cmp_Attribute_ASN1Module_Packages(Attribute_ASN1Module_Packages *value1, Attribute_ASN1Module_Packages *value2, unsigned int operator);

#define cmp_Attribute_ASN1Module_ObjectClass cmp_CMIP_1_ObjectClass
/* Comparing function for type Attribute_ASN1Module_Allomorphs */

extern OM_boolean cmp_Attribute_ASN1Module_Allomorphs(Attribute_ASN1Module_Allomorphs *value1, Attribute_ASN1Module_Allomorphs *value2, unsigned int operator);

/* Comparing function for type CFSObject_ASN1module_PermissionBits */

extern OM_boolean cmp_CFSObject_ASN1module_PermissionBits(CFSObject_ASN1module_PermissionBits *value1, CFSObject_ASN1module_PermissionBits *value2, unsigned int operator);

/* Comparing function for type CFSObject_ASN1module_FilePermissions */

extern OM_boolean cmp_CFSObject_ASN1module_FilePermissions(CFSObject_ASN1module_FilePermissions *value1, CFSObject_ASN1module_FilePermissions *value2, unsigned int operator);

#define cmp_GraphicString ca_ber_cmp_OctetString
/* Comparing function for type Attribute_ASN1Module_SystemId */

extern OM_boolean cmp_Attribute_ASN1Module_SystemId(Attribute_ASN1Module_SystemId *value1, Attribute_ASN1Module_SystemId *value2, unsigned int operator);

#define cmp_InformationFramework_AttributeType ca_ber_cmp_ObjectId
#define cmp_InformationFramework_AttributeValue ca_ber_cmp_Any
/* Comparing function for type InformationFramework_AttributeValueAssertion */

extern OM_boolean cmp_InformationFramework_AttributeValueAssertion(InformationFramework_AttributeValueAssertion *value1, InformationFramework_AttributeValueAssertion *value2, unsigned int operator);

/* Comparing function for type InformationFramework_RelativeDistinguishedName */

extern OM_boolean cmp_InformationFramework_RelativeDistinguishedName(InformationFramework_RelativeDistinguishedName *value1, InformationFramework_RelativeDistinguishedName *value2, unsigned int operator);

/* Comparing function for type InformationFramework_RDNSequence */

extern OM_boolean cmp_InformationFramework_RDNSequence(InformationFramework_RDNSequence *value1, InformationFramework_RDNSequence *value2, unsigned int operator);

#define cmp_InformationFramework_DistinguishedName cmp_InformationFramework_RDNSequence
#define cmp_Attribute_ASN1Module_DistinguishedName cmp_InformationFramework_DistinguishedName
/* Comparing function for type Attribute_ASN1Module_SystemTitle */

extern OM_boolean cmp_Attribute_ASN1Module_SystemTitle(Attribute_ASN1Module_SystemTitle *value1, Attribute_ASN1Module_SystemTitle *value2, unsigned int operator);

#define cmp_Attribute_ASN1Module_OperationalState ca_ber_cmp_Enum
#define cmp_Attribute_ASN1Module_UsageState ca_ber_cmp_Enum
#define cmp_Attribute_ASN1Module_AdministrativeState ca_ber_cmp_Enum
/* Comparing function for type Attribute_ASN1Module_SupportedFeatures_SeqT */

extern OM_boolean cmp_Attribute_ASN1Module_SupportedFeatures_SeqT(Attribute_ASN1Module_SupportedFeatures_SeqT *value1, Attribute_ASN1Module_SupportedFeatures_SeqT *value2, unsigned int operator);

/* Comparing function for type Attribute_ASN1Module_SupportedFeatures */

extern OM_boolean cmp_Attribute_ASN1Module_SupportedFeatures(Attribute_ASN1Module_SupportedFeatures *value1, Attribute_ASN1Module_SupportedFeatures *value2, unsigned int operator);

#endif /* __ASN1_H__ */

