#ifndef __CFSDIR_H__
#define __CFSDIR_H__


#include "asn1.h"

/*
** Instance structure
*/

typedef struct _cfsDir_t {

	CFSObject_ASN1module_CfsId cfsId ;
	CFSObject_ASN1module_FilePermissions cfsFilePermissions ;
	ca_binding_t *nameBinding ;
	OM_boolean packagesPresent ;
	Attribute_ASN1Module_Packages packages ;
	OM_boolean allomorphsPresent ;
	Attribute_ASN1Module_Allomorphs allomorphs ;

	/* Notifications management */
	char * attrValChngLst ;

} cfsDir_t ;


extern OM_return_code cfsDir_init(
	ca_context_t	*context,
	void		*sup,
	void		**current
) ;

extern OM_return_code cfsDir_create(
	ca_context_t	*context,
	void		*caSupRef,
	ca_binding_t	*binding,
	OM_descriptor	*localName,
	void		**caRef,
	void		**accessRef,
	OM_descriptor	*error
) ;

extern OM_return_code cfsDir_delete(
	ca_context_t	*context,
	OM_sint32	invokeId,
	OM_boolean	type,
	void		*usrRef,
	void		*caRef,
	void		*accessRef
) ;

extern OM_return_code cfsDir_free_instance(
	ca_context_t *context,
	void *caRef,
	void *usrRef
) ;

extern OM_return_code cfsDir_check(
	ca_context_t	*context,
	OM_sint		oper,
	void		*caRef,
	void		*usrRef
) ;

extern OM_return_code cfsDir_cfsId_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsDir_cfsId_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfsDir_cfsId_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfsDir_cfsFilePermissions_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsDir_cfsFilePermissions_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfsDir_cfsFilePermissions_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfsDir_objectClass_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsDir_nameBinding_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsDir_packages_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsDir_packages_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfsDir_packages_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfsDir_allomorphs_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsDir_allomorphs_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfsDir_allomorphs_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfsDir_cfsUpdateFile(
	ca_context_t	*context,
	OM_sint32	invokeId,
	OM_uint	mode,
	OM_descriptor	*actionInfoArg,
	void		*usrRef,
	void		*accessRef
) ;


/*
** Functions added for example purposes
*/

OM_return_code cfsDir_createDirectory(
	char 		*path
) ;

OM_return_code cfsDir_removeDirectory(
	ca_context_t 	*context,
	void		*usrRef
) ;

#endif /* __CFSDIR_H__ */

