/*****************************************************************************
**  File Name:          system.c
**  Generated with:     Solstice TMN Agent Toolkit 2.0
**----------------------------------------------------------------------------
**
**  Description:
**  ------------
**      The current file contains the implementation of the methods required
**      for the system class.
**      This class is defined in the following file:
**           /opt/SUNWconn/gdmo/standard/dmi.gdmo
**
**      It is part of the following GDMO document :
**           "Rec. X.721 | ISO/IEC 10165-2 : 1992"
**
**----------------------------------------------------------------------------
**
**
**      The system class is registered as 2.9.3.2.3.13
**
**      The system class contains the following attributes:
**            systemId
**            systemTitle
**            operationalState
**            usageState
**            objectClass
**            nameBinding
**            administrativeState
**            supportedFeatures
**            packages
**            allomorphs
**
**      The system class does not support any actions.
**
**      The system class does not support any notifications.
**
**      This class does not support the create operation
**      This class does not support the delete operation
**
**
*****************************************************************************/


/* 
** NOTE : 
** To find the places where you need to implement your code, 
** search for the string 'ADD YOUR'.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#ifdef WIN32
#include <xom.h>
#include <xmp.h>
#include <xmp_cmis.h>
#include <usr_caDefs.h>
#include <usr_caGo.h>
#include <usr_caDmi.h>
#include <usr_caXom.h>
#include <usr_caCtrl.h>
#include <usr_caTree.h>
#else /* WIN32 */
#include <cmip/xom.h>
#include <cmip/xmp.h>
#include <cmip/xmp_cmis.h>
#include <tmn_agent/usr_caDefs.h>
#include <tmn_agent/usr_caGo.h>
#include <tmn_agent/usr_caDmi.h>
#include <tmn_agent/usr_caXom.h>
#include <tmn_agent/usr_caCtrl.h>
#include <tmn_agent/usr_caTree.h>
#endif /* WIN32 */
#include "metadata.h"

#include "system.h"

/*
** Define the name used for binding the system object
*/
#define BINDINGNAME "cfsSystemId"

/*
** Object class OID (encoded)
*/


static OM_descriptor system_objectClass = {
	MP_ATTRIBUTE_VALUE,
	OM_S_ENCODING_STRING,
	{ 7, "\x80\x05\x59\x03\x02\x03\x0d" }
} ; /* 2.9.3.2.3.13 */


/*
** system-root name binding
*/
static ca_ident_t system_root__id = {
	"system_root",
	"1.3.6.1.4.1.42.2.2.3.0.1.1",
	{
		MP_GLOBAL_FORM, 
		OM_S_OBJECT_IDENTIFIER_STRING,
		OM_STRING("\x2b\x06\x01\x04\x01\x2a\x02\x02\x03\x00\x01\x01")
	}
} ;
static ca_binding_t system_root__binding = {
	&system_root__id,
	CA_N_NOTHING,
	NULL,
	&system_systemId__def
} ;


/*
** system_init
*/

OM_return_code system_init(
	ca_context_t	*context,
	void		*caSupRef,
	void		**caCurRef
)
{

	OM_return_code ret = OM_SUCCESS;
	OM_descriptor desc = OM_NULL_DESCRIPTOR;
	ca_ident_t * id = NULL;
	system_t *ptr = NULL;

	if (context->trace & CA_L_CALLBACK) {
		printf("INIT SYSTEM OBJECT\n") ;
	}


	/* Allocate a C structure for storing information on the system */
	/*--------------------------------------------------------------*/
	ptr = (system_t *) calloc(1, sizeof(system_t)) ;
	if (ptr == NULL) {
		printf("system_init: calloc failed\n") ;
		return OM_FUNCTION_DECLINED ;
	}

	/* Set systemId */
	/*--------------*/
	ptr->systemId.choice = Attribute_ASN1Module_SystemId_name ;
	ca_xom_strcpy0(&(ptr->systemId.value.name), BINDINGNAME) ;

	/* Fill an OM_descriptor structure for naming attribute */
	/*------------------------------------------------------*/
	desc.syntax = OM_S_GRAPHIC_STRING ;
	desc.value.string = ptr->systemId.value.name ;
	id = &systemId__id ;

	/* Set systemTitle to NULL */
	/*-------------------------*/
	ptr->systemTitle.choice = Attribute_ASN1Module_SystemTitle_nothing ;

	/* Set operationalState */
	/*----------------------*/
	ptr->operationalState = CA_DMI_ENABLED ;

	/* Set usageState */
	/*----------------*/
	ptr->usageState = CA_DMI_ACTIVE ;

	/* Set nameBinding */
	/*-----------------*/
	ptr->nameBinding = &system_root__binding;

	/* Set administrativeState */
	/*-------------------------*/
	ptr->administrativeState = CA_DMI_UNLOCKED ;
	ptr->administrativeStatePresent = OM_TRUE ;

	/* Declare the instance in the containment tree. Specify the class, */
	/* naming attribute, and value of the attribute. References to the  */
	/* superior instance should be NULL as the instance to be inserted  */
	/* is at the top of the tree.                                       */
	/*------------------------------------------------------------------*/
	ret = ca_addInstWithSupInTree(
		context,
		&system__def,
		id,
		&desc,
		NULL,
		caSupRef,
		ptr,
		caCurRef
		) ;

	if (ret != OM_SUCCESS) {
		printf("system_init: ca_addInstWithSupInTree failed\n") ;
		if (ptr != NULL) free(ptr) ;
		return ret ;
	}

	/* Trace */
	/*-------*/
	if (context->trace & CA_L_PRINT_TREE) {
		ca_examinTree(context) ;
	}
	if (context->trace & CA_L_CALLBACK) {
		printf("INIT SYSTEM OBJECT: DONE\n") ;
	}

	return ret ;

}

/*
** system_check
*/

OM_return_code system_check(
	ca_context_t	*context,
	OM_sint		oper,
	void 		*caRef,
	void 		*usrRef
)
{
	OM_return_code	ret ;
	system_t	*instance ;

	instance = (system_t *) usrRef ;


	return OM_SUCCESS ;
}


/*
** system_systemId_get
*/

OM_return_code system_systemId_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t	*instance ;

	instance = (system_t *) usrRef ;
	ret = enc_Attribute_ASN1Module_SystemId(
		&(instance->systemId),
		value
	);

	return ret ;
}


/*
** system_systemId_eval
*/

OM_return_code system_systemId_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t *instance;
	Attribute_ASN1Module_SystemId decodedValue;

	instance = (system_t *) usrRef ;

	if (type == MP_PRESENT) {
		*result = OM_TRUE ;
		*error = OM_FALSE ;
	}
	else {
		/*
		** Decode value1
		*/
		ret = dec_Attribute_ASN1Module_SystemId(value1, &decodedValue) ;

		/*
		** Compare the decoded value to the value stored
		** in the instance structure.
		*/
		if (ret == OM_SUCCESS) {
			switch(type) {

			case MP_EQUALITY :
				*result = cmp_Attribute_ASN1Module_SystemId(
					&decodedValue,
					&instance->systemId,
					type
				) ;
				*error = OM_FALSE ;
				break ;

			default :
				*result = OM_FALSE ;
				*error = OM_TRUE ;
				break ;

			}
		}
		else if (ret == OM_ENCODING_INVALID) {
			*error = OM_TRUE ;
			ret = OM_SUCCESS ; 
		}

		/*
		** Cleaning
		*/
		if (ret == OM_SUCCESS)
			free_Attribute_ASN1Module_SystemId(&decodedValue) ;
	}

	return ret ;
}


/*
** system_systemTitle_get
*/

OM_return_code system_systemTitle_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t	*instance ;

	instance = (system_t *) usrRef ;
	ret = enc_Attribute_ASN1Module_SystemTitle(
		&(instance->systemTitle),
		value
	);

	return ret ;
}


/*
** system_systemTitle_eval
*/

OM_return_code system_systemTitle_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t *instance;
	Attribute_ASN1Module_SystemTitle decodedValue;

	instance = (system_t *) usrRef ;

	if (type == MP_PRESENT) {
		*result = OM_TRUE ;
		*error = OM_FALSE ;
	}
	else {
		/*
		** Decode value1
		*/
		ret = dec_Attribute_ASN1Module_SystemTitle(value1, &decodedValue) ;

		/*
		** Compare the decoded value to the value stored
		** in the instance structure.
		*/
		if (ret == OM_SUCCESS) {
			switch(type) {

			case MP_EQUALITY :
				*result = cmp_Attribute_ASN1Module_SystemTitle(
					&decodedValue,
					&instance->systemTitle,
					type
				) ;
				*error = OM_FALSE ;
				break ;

			default :
				*result = OM_FALSE ;
				*error = OM_TRUE ;
				break ;

			}
		}
		else if (ret == OM_ENCODING_INVALID) {
			*error = OM_TRUE ;
			ret = OM_SUCCESS ; 
		}

		/*
		** Cleaning
		*/
		if (ret == OM_SUCCESS)
			free_Attribute_ASN1Module_SystemTitle(&decodedValue) ;
	}

	return ret ;
}


/*
** system_operationalState_get
*/

OM_return_code system_operationalState_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t	*instance ;

	instance = (system_t *) usrRef ;
	ret = enc_Attribute_ASN1Module_OperationalState(
		&(instance->operationalState),
		value
	);

	return ret ;
}


/*
** system_operationalState_eval
*/

OM_return_code system_operationalState_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t *instance;
	Attribute_ASN1Module_OperationalState decodedValue;

	instance = (system_t *) usrRef ;

	if (type == MP_PRESENT) {
		*result = OM_TRUE ;
		*error = OM_FALSE ;
	}
	else {
		/*
		** Decode value1
		*/
		ret = dec_Attribute_ASN1Module_OperationalState(value1, &decodedValue) ;

		/*
		** Compare the decoded value to the value stored
		** in the instance structure.
		*/
		if (ret == OM_SUCCESS) {
			switch(type) {

			case MP_EQUALITY :
				*result = cmp_Attribute_ASN1Module_OperationalState(
					&decodedValue,
					&instance->operationalState,
					type
				) ;
				*error = OM_FALSE ;
				break ;

			default :
				*result = OM_FALSE ;
				*error = OM_TRUE ;
				break ;

			}
		}
		else if (ret == OM_ENCODING_INVALID) {
			*error = OM_TRUE ;
			ret = OM_SUCCESS ; 
		}

		/*
		** Cleaning
		*/
		if (ret == OM_SUCCESS)
			free_Attribute_ASN1Module_OperationalState(&decodedValue) ;
	}

	return ret ;
}


/*
** system_usageState_get
*/

OM_return_code system_usageState_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t	*instance ;

	instance = (system_t *) usrRef ;
	ret = enc_Attribute_ASN1Module_UsageState(
		&(instance->usageState),
		value
	);

	return ret ;
}


/*
** system_usageState_eval
*/

OM_return_code system_usageState_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t *instance;
	Attribute_ASN1Module_UsageState decodedValue;

	instance = (system_t *) usrRef ;

	if (type == MP_PRESENT) {
		*result = OM_TRUE ;
		*error = OM_FALSE ;
	}
	else {
		/*
		** Decode value1
		*/
		ret = dec_Attribute_ASN1Module_UsageState(value1, &decodedValue) ;

		/*
		** Compare the decoded value to the value stored
		** in the instance structure.
		*/
		if (ret == OM_SUCCESS) {
			switch(type) {

			case MP_EQUALITY :
				*result = cmp_Attribute_ASN1Module_UsageState(
					&decodedValue,
					&instance->usageState,
					type
				) ;
				*error = OM_FALSE ;
				break ;

			default :
				*result = OM_FALSE ;
				*error = OM_TRUE ;
				break ;

			}
		}
		else if (ret == OM_ENCODING_INVALID) {
			*error = OM_TRUE ;
			ret = OM_SUCCESS ; 
		}

		/*
		** Cleaning
		*/
		if (ret == OM_SUCCESS)
			free_Attribute_ASN1Module_UsageState(&decodedValue) ;
	}

	return ret ;
}


/*
** system_objectClass_get
*/

OM_return_code system_objectClass_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	value->syntax = system_objectClass.syntax ;
	value->value  = system_objectClass.value ;

	return OM_SUCCESS;
}


/*
** system_nameBinding_get
*/

OM_return_code system_nameBinding_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	system_t	*instance ;

	instance = (system_t *) usrRef ;
	if (instance->nameBinding != NULL) {
		value->syntax = instance->nameBinding->id->priv.syntax ;
		value->value = instance->nameBinding->id->priv.value ;
	}
	else {
		value->syntax = OM_S_NULL ;
	}

	return OM_SUCCESS;
}


/*
** system_administrativeState_get
*/

OM_return_code system_administrativeState_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t	*instance ;

	instance = (system_t *) usrRef ;
	if (instance->administrativeStatePresent == OM_TRUE) {
		ret = enc_Attribute_ASN1Module_AdministrativeState(
			&(instance->administrativeState), 
			value
		) ;
	}
	else {
		value->type = MP_ERROR_STATUS;
		value->syntax = OM_S_ENUMERATION;
		value->value.enumeration=MP_E_NO_SUCH_ATTRIBUTE;
		ret = OM_SUCCESS ;
	}
	return ret ;
}


/*
** system_administrativeState_set
*/

OM_return_code system_administrativeState_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
)
{
	OM_return_code ret;
	system_t *instance;
	Attribute_ASN1Module_AdministrativeState decodedValue;

	instance = (system_t *) usrRef ;

	/*
	** ADD YOUR CODE HERE:
	** The attribute is conditional.
	** By default the setting of the attribute is allowed.
	** You can add your code below to disallow setting of
	** the attribute for the current instance.
	*/

	/*
	** Decode the new value
	*/
	ret = dec_Attribute_ASN1Module_AdministrativeState(valueForOperation, &decodedValue) ;
	if (ret == OM_SUCCESS) {
		ret = ca_copy_xom_value(resultingValue, valueForOperation) ;
		if (ret != OM_SUCCESS) {
			free_Attribute_ASN1Module_AdministrativeState(&decodedValue) ;
		}
	}
	else if (ret == OM_ENCODING_INVALID) {
		resultingValue->type = MP_ERROR_STATUS;
		resultingValue->syntax = OM_S_ENUMERATION;
		resultingValue->value.enumeration =
					MP_E_INVALID_ATTRIBUTE_VALUE;
	}
	/*
	** Copy the decoded value in the managed object
	*/
	if (ret == OM_SUCCESS) {
		if (instance->administrativeStatePresent)
			free_Attribute_ASN1Module_AdministrativeState(&(instance->administrativeState)) ;
		instance->administrativeState = decodedValue ;
		instance->administrativeStatePresent = OM_TRUE ;
	}

	/*
	** ADD YOUR CODE HERE:
	** Managed object is now updated.
	** You can code here to update the managed resource.
	*/
	if (ret == OM_SUCCESS) {


	}

	/*
	** When a CMIS error is reported, return code must be cleared.
	*/
	if (resultingValue->type == MP_ERROR_STATUS) {
		ret = OM_SUCCESS ;
	}

	return ret ;
}


/*
** system_administrativeState_eval
*/

OM_return_code system_administrativeState_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t *instance;
	Attribute_ASN1Module_AdministrativeState decodedValue;

	instance = (system_t *) usrRef ;

	if (type == MP_PRESENT) {
		*result = instance->administrativeStatePresent ;
		*error = OM_FALSE ;
	}
	else {
		/*
		** Decode value1
		*/
		ret = dec_Attribute_ASN1Module_AdministrativeState(value1, &decodedValue) ;

		/*
		** Compare the decoded value to the value stored
		** in the instance structure.
		*/
		if (ret == OM_SUCCESS) {
			switch(type) {

			case MP_EQUALITY :
				*result = cmp_Attribute_ASN1Module_AdministrativeState(
					&decodedValue,
					&instance->administrativeState,
					type
				) ;
				*error = OM_FALSE ;
				break ;

			default :
				*result = OM_FALSE ;
				*error = OM_TRUE ;
				break ;

			}
		}
		else if (ret == OM_ENCODING_INVALID) {
			*error = OM_TRUE ;
			ret = OM_SUCCESS ; 
		}

		/*
		** Cleaning
		*/
		if (ret == OM_SUCCESS)
			free_Attribute_ASN1Module_AdministrativeState(&decodedValue) ;
	}

	return ret ;
}


/*
** system_supportedFeatures_get
*/

OM_return_code system_supportedFeatures_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t	*instance ;

	instance = (system_t *) usrRef ;
	if (instance->supportedFeaturesPresent == OM_TRUE) {
		ret = enc_Attribute_ASN1Module_SupportedFeatures(
			&(instance->supportedFeatures), 
			value
		) ;
	}
	else {
		value->type = MP_ERROR_STATUS;
		value->syntax = OM_S_ENUMERATION;
		value->value.enumeration=MP_E_NO_SUCH_ATTRIBUTE;
		ret = OM_SUCCESS ;
	}
	return ret ;
}


/*
** system_supportedFeatures_set
*/

OM_return_code system_supportedFeatures_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
)
{
	OM_return_code ret;
	system_t *instance;
	Attribute_ASN1Module_SupportedFeatures decodedValue;

	instance = (system_t *) usrRef ;

	/*
	** ADD YOUR CODE HERE:
	** The attribute is conditional.
	** By default the setting of the attribute is allowed.
	** You can add your code below to disallow setting of
	** the attribute for the current instance.
	*/

	/*
	** Decode the new value
	*/
	ret = dec_Attribute_ASN1Module_SupportedFeatures(valueForOperation, &decodedValue) ;
	if (ret == OM_SUCCESS) {
		ret = ca_copy_xom_value(resultingValue, valueForOperation) ;
		if (ret != OM_SUCCESS) {
			free_Attribute_ASN1Module_SupportedFeatures(&decodedValue) ;
		}
	}
	else if (ret == OM_ENCODING_INVALID) {
		resultingValue->type = MP_ERROR_STATUS;
		resultingValue->syntax = OM_S_ENUMERATION;
		resultingValue->value.enumeration =
					MP_E_INVALID_ATTRIBUTE_VALUE;
	}
	/*
	** Copy the decoded value in the managed object
	*/
	if (ret == OM_SUCCESS) {
		if (instance->supportedFeaturesPresent)
			free_Attribute_ASN1Module_SupportedFeatures(&(instance->supportedFeatures)) ;
		instance->supportedFeatures = decodedValue ;
		instance->supportedFeaturesPresent = OM_TRUE ;
	}

	/*
	** ADD YOUR CODE HERE:
	** Managed object is now updated.
	** You can code here to update the managed resource.
	*/
	if (ret == OM_SUCCESS) {


	}

	/*
	** When a CMIS error is reported, return code must be cleared.
	*/
	if (resultingValue->type == MP_ERROR_STATUS) {
		ret = OM_SUCCESS ;
	}

	return ret ;
}


/*
** system_supportedFeatures_eval
*/

OM_return_code system_supportedFeatures_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t *instance;
	Attribute_ASN1Module_SupportedFeatures decodedValue;

	instance = (system_t *) usrRef ;

	if (type == MP_PRESENT) {
		*result = instance->supportedFeaturesPresent ;
		*error = OM_FALSE ;
	}
	else {
		/*
		** Decode value1
		*/
		ret = dec_Attribute_ASN1Module_SupportedFeatures(value1, &decodedValue) ;

		/*
		** Compare the decoded value to the value stored
		** in the instance structure.
		*/
		if (ret == OM_SUCCESS) {
			switch(type) {

			case MP_EQUALITY :
			case MP_SUBSET_OF :
			case MP_SUPERSET_OF :
			case MP_NON_NULL_SET_INTERSECTION :
				*result = cmp_Attribute_ASN1Module_SupportedFeatures(
					&decodedValue,
					&instance->supportedFeatures,
					type
				) ;
				*error = OM_FALSE ;
				break ;

			default :
				*result = OM_FALSE ;
				*error = OM_TRUE ;
				break ;

			}
		}
		else if (ret == OM_ENCODING_INVALID) {
			*error = OM_TRUE ;
			ret = OM_SUCCESS ; 
		}

		/*
		** Cleaning
		*/
		if (ret == OM_SUCCESS)
			free_Attribute_ASN1Module_SupportedFeatures(&decodedValue) ;
	}

	return ret ;
}


/*
** system_packages_get
*/

OM_return_code system_packages_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t	*instance ;

	instance = (system_t *) usrRef ;
	if (instance->packagesPresent == OM_TRUE) {
		ret = enc_Attribute_ASN1Module_Packages(
			&(instance->packages), 
			value
		) ;
	}
	else {
		value->type = MP_ERROR_STATUS;
		value->syntax = OM_S_ENUMERATION;
		value->value.enumeration=MP_E_NO_SUCH_ATTRIBUTE;
		ret = OM_SUCCESS ;
	}
	return ret ;
}


/*
** system_packages_eval
*/

OM_return_code system_packages_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t *instance;
	Attribute_ASN1Module_Packages decodedValue;

	instance = (system_t *) usrRef ;

	if (type == MP_PRESENT) {
		*result = instance->packagesPresent ;
		*error = OM_FALSE ;
	}
	else {
		/*
		** Decode value1
		*/
		ret = dec_Attribute_ASN1Module_Packages(value1, &decodedValue) ;

		/*
		** Compare the decoded value to the value stored
		** in the instance structure.
		*/
		if (ret == OM_SUCCESS) {
			switch(type) {

			case MP_EQUALITY :
			case MP_SUBSET_OF :
			case MP_SUPERSET_OF :
			case MP_NON_NULL_SET_INTERSECTION :
				*result = cmp_Attribute_ASN1Module_Packages(
					&decodedValue,
					&instance->packages,
					type
				) ;
				*error = OM_FALSE ;
				break ;

			default :
				*result = OM_FALSE ;
				*error = OM_TRUE ;
				break ;

			}
		}
		else if (ret == OM_ENCODING_INVALID) {
			*error = OM_TRUE ;
			ret = OM_SUCCESS ; 
		}

		/*
		** Cleaning
		*/
		if (ret == OM_SUCCESS)
			free_Attribute_ASN1Module_Packages(&decodedValue) ;
	}

	return ret ;
}


/*
** system_allomorphs_get
*/

OM_return_code system_allomorphs_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t	*instance ;

	instance = (system_t *) usrRef ;
	if (instance->allomorphsPresent == OM_TRUE) {
		ret = enc_Attribute_ASN1Module_Allomorphs(
			&(instance->allomorphs), 
			value
		) ;
	}
	else {
		value->type = MP_ERROR_STATUS;
		value->syntax = OM_S_ENUMERATION;
		value->value.enumeration=MP_E_NO_SUCH_ATTRIBUTE;
		ret = OM_SUCCESS ;
	}
	return ret ;
}


/*
** system_allomorphs_eval
*/

OM_return_code system_allomorphs_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
)
{
	OM_return_code ret = OM_SUCCESS;
	system_t *instance;
	Attribute_ASN1Module_Allomorphs decodedValue;

	instance = (system_t *) usrRef ;

	if (type == MP_PRESENT) {
		*result = instance->allomorphsPresent ;
		*error = OM_FALSE ;
	}
	else {
		/*
		** Decode value1
		*/
		ret = dec_Attribute_ASN1Module_Allomorphs(value1, &decodedValue) ;

		/*
		** Compare the decoded value to the value stored
		** in the instance structure.
		*/
		if (ret == OM_SUCCESS) {
			switch(type) {

			case MP_EQUALITY :
			case MP_SUBSET_OF :
			case MP_SUPERSET_OF :
			case MP_NON_NULL_SET_INTERSECTION :
				*result = cmp_Attribute_ASN1Module_Allomorphs(
					&decodedValue,
					&instance->allomorphs,
					type
				) ;
				*error = OM_FALSE ;
				break ;

			default :
				*result = OM_FALSE ;
				*error = OM_TRUE ;
				break ;

			}
		}
		else if (ret == OM_ENCODING_INVALID) {
			*error = OM_TRUE ;
			ret = OM_SUCCESS ; 
		}

		/*
		** Cleaning
		*/
		if (ret == OM_SUCCESS)
			free_Attribute_ASN1Module_Allomorphs(&decodedValue) ;
	}

	return ret ;
}


