#ifdef __sun
#pragma ident "@(#)usr_caLog.h	1.8 97/07/08 Copyright SMI"
#endif
/****************************************************************************/
/*  File Name: 		usr_caLog.h                                         */
/*  Creation date:	07/08/97                                            */
/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  Description:                                                            */
/*  -----------                                                             */
/*      The current file contains definitions required by the use of the    */
/*      log object.                                                         */
/*                                                                          */
/****************************************************************************/

#ifndef _USR_CALOG_H
#define _USR_CALOG_H

#ifdef  __cplusplus
extern "C" {
#endif

/*                Declarations of the LOG class description                 */
/*--------------------------------------------------------------------------*/
extern ca_class_t logClass[];
extern ca_class_t alarmRecordClass[];
extern ca_class_t attributeValueChangeRecordClass[];
extern ca_class_t eventLogRecordClass[];
extern ca_class_t logRecordClass[];
extern ca_class_t objectCreationRecordClass[];
extern ca_class_t objectDeletionRecordClass[];
extern ca_class_t relationshipChangeRecordClass[];
extern ca_class_t securityAlarmReportRecordClass[];
extern ca_class_t stateChangeRecordClass[];

/*
 */
typedef struct ca_dmi_logR_inline_t {
	OM_uint32	size;
	void		*rec;
} ca_dmi_logR_inline_t;

typedef void *logDB_handle;

/*                   Declarations of the LOG functions                      */
/*--------------------------------------------------------------------------*/
#if defined(__STDC__)

extern OM_return_code ca_dmi_log_create(
        ca_context_t                    *cont,  /* context of core agent */
        OM_descriptor                   *ava,   /* name of instance      */
	OM_boolean			wrap,	/* Action when log is full */
	OM_uint32			maxLogSize, /* Maximum log size. */
        OM_private_object               filter,  /* filter for construct  */
	void				**caRef	/* Toolkit reference */
	);

extern OM_return_code ca_dmi_log_delete(
	ca_context_t			*cont,	/* context of core agent */
	void				*caRef	/* Toolkit reference */
	);

#ifndef _USR_CAEFD_H
extern OM_return_code ca_dmi_object_init(
        ca_context_t            	*cont,
        ca_generic_attribute_t  	*listOfAtt[],
	ca_gdmo_notif_t         	*listOfNotif[],
	ca_ident_t              	*bindingName,
	ca_class_t              	*superiorClass,
	char				scheduling
	);
#endif

extern logDB_handle	logDB_create(
	ca_context_t	*cont,
	OM_descriptor	*logId,
	OM_uint32	logWrap,
	OM_uint32	maxLogSize
	);

extern OM_return_code	logDB_delete(
	ca_context_t	*cont,
	logDB_handle	db
	);

extern OM_return_code	logDB_save(
	ca_context_t	*cont,
	logDB_handle	db,
	OM_uint32	cleanLog
	);

extern OM_return_code	logDB_param(
	ca_context_t	*cont,
	logDB_handle	db,
	OM_uint32	logWrap,
	OM_uint32	maxLogSize
	);

extern OM_return_code	logRecord_store(
	ca_context_t	*cont,
	logDB_handle	db,
	OM_uint32	id,
	ca_dmi_logR_inline_t *rec
	);

extern OM_return_code	logRecord_fetch(
	ca_context_t	*cont,
	logDB_handle	db,
	OM_uint32	id,
	OM_uint32	*size
	);

extern OM_return_code	logRecord_delete(
	ca_context_t	*cont,
	logDB_handle	db,
	OM_uint32	id
	);

#else

extern OM_return_code ca_dmi_log_create();
extern OM_return_code ca_dmi_log_delete();
#ifndef _USR_CAEFD_H
extern OM_return_code ca_dmi_object_init();
#endif
extern logDB_handle logDB_create();
extern OM_return_code logDB_delete();
extern OM_return_code logDB_save();
extern OM_return_code logDB_param();
extern OM_return_code logRecord_store();
extern OM_return_code logRecord_fetch();
extern OM_return_code logRecord_delete();

#endif

#ifdef  __cplusplus
}
#endif
 
 
#endif  /* _USR_CALOG_H */

